#include "dofd.h"
#include <math.h>


void DunBeam(
    dungeon_se *a_dun_se , 
    char aaa_map[ 5][ 75][ 100] ,
    int *a_j_kasan ,
    int *a_i_kasan ,
    dungeon_beam *a_beam,
    int *a_beam_counter,
    int *a_beam_set,
    int *a_n_beam,
    action_tekitama aa_tekitama[ 100][ TEKITAMA],
    gazo_gun *a_ga, 
    switch_gun *a_sw ){


    int i,j;
    float xx,yy,zz;
    
        for( i = 0 ; i < *a_n_beam ; i++ ){

            if( a_beam[ i].hpzan > 0){

                for( j = 0 ; j < TEKITAMA ; j++ ){

                    if( aa_tekitama[ i][ j].hpzan == 0 ){

                        if( j == *a_beam_set){

                            aa_tekitama[ i][ j].t = 0;

                            xx = a_dun_se->x - a_beam[ i].x0;
                            yy = a_dun_se->y - a_beam[ i].y0;
                            
                            zz = sqrt( xx * xx + yy * yy);
                            
                            aa_tekitama[ i][ j].xz = xx / zz;
                            aa_tekitama[ i][ j].yz = yy / zz;
                            aa_tekitama[ i][ j].hpzan = 1;
                        }


                    }
                    
                    else if( aa_tekitama[ i][ j].hpzan > 0){
                        aa_tekitama[ i][ j].x = a_beam[ i].x0 + 3 * aa_tekitama[ i][ j].t  * aa_tekitama[ i][ j].xz ;
                        aa_tekitama[ i][ j].y = a_beam[ i].y0 + 3 * aa_tekitama[ i][ j].t  * aa_tekitama[ i][ j].yz ;
                        
                        DrawGraph(
                            aa_tekitama[ i][ j].x - *a_i_kasan * 32, 
                            aa_tekitama[ i][ j].y - *a_j_kasan * 32, 
                            a_ga->tekitama ,
                            TRUE                                    
                        ) ;

                    
                        aa_tekitama[ i][ j].t++;

                        if(
                              aa_tekitama[ i][ j].x -  *a_i_kasan * 32 <   0 * 32 
                           || aa_tekitama[ i][ j].x -  *a_i_kasan * 32 >= 20 * 32
                           || aa_tekitama[ i][ j].y -  *a_j_kasan * 32 <   0 * 32 
                           || aa_tekitama[ i][ j].y -  *a_j_kasan * 32 >= 15 * 32
                                                                             ){ 
                            aa_tekitama[ i][ j].hpzan = 0;
                        }

                        DunAtariJokenTekitama( 
                            a_dun_se , 
                            aa_tekitama , 
                            i ,
                            j
                        );

                    }
                    else{}
                    
                }//for
            }    
        }

        (*a_beam_counter)++;
        *a_beam_set =  *a_beam_counter / 30 % TEKITAMA;    

}


void DunAtariJokenTekitama(
    dungeon_se  *a_dun_se , 
    action_tekitama aa_tekitama[ 100][ TEKITAMA] , 
    int i ,
    int j ){

    //se
    int ax1 = a_dun_se->x +      ATARIHABA_SE;
    int ay1 = a_dun_se->y +      ATARIHABA_SE;
    int ax2 = a_dun_se->x + 48 - ATARIHABA_SE ;
    int ay2 = a_dun_se->y + 48 - ATARIHABA_SE ;



    int bx1 = aa_tekitama[ i][ j].x  ;
    int by1 = aa_tekitama[ i][ j].y  ;
    int bx2 = aa_tekitama[ i][ j].x + 8 ;
    int by2 = aa_tekitama[ i][ j].y + 8 ;
    
    if( ( ax1<bx2) && ( bx1<ax2) && ( ay1<by2) && ( by1<ay2) ){
        if( aa_tekitama[ i][ j].hpzan > 0){
            a_dun_se->hpzan -= 50;
        }
        aa_tekitama[ i][ j].hpzan = 0;
    }
    else{
        
    }
}


