#include "dofd.h"

int SimMikataHaichi(
    simulation_unit *a_unit,
    int i_mikata,
    int n_mikata,
    int n_teki,
    int *a_mikata_zan,
    int *a_teki_zan,
    int *a_sw_ke_meirei,
    gazo_gun  *a_ga,
    int aa_ban[ 8][ 8]){

    /******************************************************************
    *                                                                 *
    * ̃jbgij蓮Ŕzu                            *
    * J[\Ăƃjbgij̃Xe[^X\          *
    *                                                                 *
    ******************************************************************/

    int i, j;
    int i_teki;

    int tsukamu = 0;
    int key;
    int flip_counter = 6;
    int hani_x, hani_y;
    int genkai;

    struct simulation_kasoru kasoru_mikata;
    
    int ban_num;
    int ban_hosu;
    int ban_shatei;
    int ban_hpzan;
    int ban_hp;
    int ban_kogeki;
    int ban_hangeki;

    char a_jigun[ 25];
    char a_tekigun[ 25];
    char a_unit_num[ 25];
    char a_name[ 25];
    char a_job[ 25];
    char a_hosu[ 25];
    char a_shatei[ 25];
    
    char a_hpzan[ 25];
    char a_hp[ 25];
    char a_kogeki[ 25];
    char a_hangeki[ 25];
    
    kasoru_mikata.x = a_unit[ i_mikata].x;
    kasoru_mikata.y = a_unit[ i_mikata].y;

    while(     ProcessMessage() == 0
            && CheckHitKey( KEY_INPUT_ESCAPE) == 0 ){
    
        ClsDrawScreen();

        SimBan(
            a_ga,
            aa_ban );

        DrawGraph( 
            kasoru_mikata.x , 
            kasoru_mikata.y , 
            a_ga->a_kasoru[ 0] , 
            TRUE 
        );

        if( tsukamu == 0){

            if ( flip_counter == 6 ){

                key = GetJoypadInputState( DX_INPUT_KEY_PAD1);
        
                if( key & PAD_INPUT_UP    ){ 
                    kasoru_mikata.y -= 48;
                    flip_counter = 0;
                    if( kasoru_mikata.y < 48){ kasoru_mikata.y = 48;}
                }

                if( key & PAD_INPUT_DOWN  ){ 
                    kasoru_mikata.y += 48;
                    flip_counter = 0;
                    if( kasoru_mikata.y > 384){ kasoru_mikata.y = 384;}
                }

                if( key & PAD_INPUT_LEFT  ){ 
                    kasoru_mikata.x -= 48;
                    flip_counter = 0;
                    if( kasoru_mikata.x < 208){ kasoru_mikata.x = 208;}
                }

                if( key & PAD_INPUT_RIGHT ){ 
                    kasoru_mikata.x += 48;
                    flip_counter = 0;
                    if( kasoru_mikata.x > 544){ kasoru_mikata.x = 544;}
                }

            }
            else if( flip_counter < 6 ){
                flip_counter ++;
            }
            else{}

            DrawGraph( 
                kasoru_mikata.x , 
                kasoru_mikata.y , 
                a_ga->a_kasoru[ 0], 
                TRUE 
            );

            if(
                   kasoru_mikata.y >= 48
                && kasoru_mikata.y <= 432
                && kasoru_mikata.x >= 208
                && kasoru_mikata.x <= 544
                                            ){

                ban_num 
                    = aa_ban[( kasoru_mikata.y - 48 ) / 48]
                            [( kasoru_mikata.x - 208 ) / 48];

            }

            sprintf( a_hpzan, "RF %2d/%2d", *a_mikata_zan, n_mikata - 10);
            DrawString( 16 , 16 , a_hpzan , GetColor( 0, 0, 255) , TRUE ) ;

            sprintf( a_hpzan , "GRF %2d/%2d", *a_teki_zan , n_teki - 30 );
            DrawString( 16 , 32 , a_hpzan , GetColor( 0, 0, 255) , TRUE ) ;

            sprintf( a_unit_num , "UNITF%6d", ban_num );
            DrawString( 16 , 48 , a_unit_num , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { strcpy( a_name , "");}
            else                  { strcpy( a_name , a_unit[ ban_num].a_name);}
            DrawString( 16 , 64 , a_name , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { strcpy( a_job , "");}
            else                  { strcpy( a_job , a_unit[ ban_num].a_job);}
            DrawString( 16 , 80 , a_job , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_hosu = 0;}
            else                  { ban_hosu = a_unit[ ban_num].hosu;}
            sprintf( a_hosu , "F%6d", ban_hosu);
            DrawString( 16 , 96 , a_hosu , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_shatei = 0;}
            else                  { ban_shatei = a_unit[ ban_num].shatei;}
            sprintf( a_shatei , "˒F%6d", ban_shatei);
            DrawString( 16 , 112 , a_shatei , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_hpzan = 0;}
            else                  { ban_hpzan = a_unit[ ban_num].hpzan;}
            sprintf( a_hpzan , "HPcF%6d", ban_hpzan);
            DrawString( 16 , 128 , a_hpzan , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_hp = 0;}
            else                  { ban_hp = a_unit[ ban_num].hp;}
            sprintf( a_hp , "goF%6d", ban_hp);
            DrawString( 16 , 144 , a_hp , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_kogeki = 0;}
            else                  { ban_kogeki = a_unit[ ban_num].kogeki;}
            sprintf( a_kogeki , "UF%6d", ban_kogeki);
            DrawString( 16 , 160 , a_kogeki , GetColor( 0, 0, 255) , TRUE ) ;

            if( ban_num == 0)     { ban_hangeki = 0;}
            else                  { ban_hangeki = a_unit[ ban_num].hangeki;}
            sprintf( a_hangeki , "F%6d", ban_hangeki );
            DrawString( 16 , 176 , a_hangeki , GetColor( 0, 0, 255) , TRUE ) ;

            if( key & PAD_INPUT_A ){
                while(( ProcessMessage() == 0)&&( CheckHitKeyAll() != 0)){}
                if(     
                        a_unit[ i_mikata ].ido == OFF
                                                        ){

                    kasoru_mikata.x = a_unit[ i_mikata].x;
                    kasoru_mikata.y = a_unit[ i_mikata].y;

                    tsukamu = ON;
                    a_unit[ i_mikata ].tsukamu = ON;
                    aa_ban[( kasoru_mikata.y -  48 ) / 48]
                          [( kasoru_mikata.x - 208 ) / 48] = OFF; 
                    hani_x = 0;
                    hani_y = 0;
                }
            }
        }
        else if( tsukamu == 1) {
        
            if( i_mikata == 14){
                if( *a_sw_ke_meirei == 0){
            
                    SimHaichi( a_unit , a_ga , aa_ban );
                    BunYomi(
                        a_ga,
                        "media\\sim_ke_meirei.txt"
                    );
                
                    *a_sw_ke_meirei = 1;
                }
            
                goto ke_tobisaki;
            }

            if ( flip_counter == 6 ){

                key = GetJoypadInputState( DX_INPUT_KEY_PAD1);
        
                if( key & PAD_INPUT_UP    ){ 
                    flip_counter = 0;


                    if(    i_mikata == 12 
                        || i_mikata == 13 ){
                        genkai = 0;
                    }
                    else{
                        genkai = -48;
                    }
                    
                    if(hani_y >= genkai){
    
                        hani_y -= 48;
                        kasoru_mikata.y -= 48;


                        if( kasoru_mikata.y < 48){ kasoru_mikata.y = 48;}
                    }


                }
                if( key & PAD_INPUT_DOWN  ){ 
                    flip_counter = 0;

                    if(    i_mikata == 12 
                        || i_mikata == 13 ){
                        genkai = 0;
                    }
                    else{
                        genkai = 48;
                    }

                    if( hani_y <= genkai){
                        hani_y += 48;
                        kasoru_mikata.y += 48;
                        if( kasoru_mikata.y > 384){ kasoru_mikata.y = 384;}
                    }
                }
                if( key & PAD_INPUT_LEFT  ){ 
                    flip_counter = 0;

                    if(    i_mikata == 12 
                        || i_mikata == 13 ){
                        genkai = 0;
                    }
                    else{
                        genkai = -48;
                    }

                    if( hani_x >= genkai){
                        hani_x -= 48;
                        kasoru_mikata.x -= 48;
                        if( kasoru_mikata.x < 208){ kasoru_mikata.x = 208;}
                    }
                }
                if( key & PAD_INPUT_RIGHT ){ 
                    flip_counter = 0;

                    if(    i_mikata == 12 
                        || i_mikata == 13 ){
                        genkai = 0;
                    }
                    else{
                        genkai = 48;
                    }

                    if( hani_x <= genkai){
                        hani_x += 48;
                        kasoru_mikata.x += 48;
                        if( kasoru_mikata.x > 544){ kasoru_mikata.x = 544;}
                    }
                }
            }
            else if( flip_counter < 6 ){
                flip_counter ++;
            }
            else{}

            DrawGraph( 
                kasoru_mikata.x , 
                kasoru_mikata.y , 
                a_ga->a_kasoru[ 1] , 
                TRUE 
            );

            ke_tobisaki:
        
            if ( aa_ban[( kasoru_mikata.y -  48 ) / 48]
                       [( kasoru_mikata.x - 208 ) / 48] == OFF){

                if( key & PAD_INPUT_A ){
                    while(( ProcessMessage() == 0)&&( CheckHitKeyAll() != 0)){}
                    aa_ban[( kasoru_mikata.y -  48 ) / 48]
                          [( kasoru_mikata.x - 208 ) / 48] = i_mikata;                
                    tsukamu = 0;
                    a_unit[ i_mikata ].tsukamu = OFF;
                    a_unit[ i_mikata ].ido = OK;
                    a_unit[ i_mikata ].x = kasoru_mikata.x; 
                    a_unit[ i_mikata ].y = kasoru_mikata.y; 
                    return 0;
                }
            }
            
        }

        SimHaichi( a_unit , a_ga , aa_ban );

        ScreenFlip();

    }
    
    return 0;

}