#include "dofd.h"
#include <math.h>

int SimTekiTansaku(
    simulation_unit *a_unit,
    int i_teki,
    int n_mikata ){

    /******************************************************************
    *                                                                 *
    * GHP̌ԑ傫̂˂炤                          *
    * U͈͂ɂȂΈԋ߂̂˂炤                          *
    *                                                                 *
    ******************************************************************/

    int i_mikata;
    
    float wk_kyori = 10000;
    int wk_hpzan = -1;
    int nerai1 = 0;
    int nerai2 = 0;
    int nerai  = 0;

    for( i_mikata = 10 ; i_mikata < n_mikata ; i_mikata++){

        if( a_unit[ i_mikata].hpzan > 0){

            float x_kyori = a_unit[ i_teki].x - a_unit[ i_mikata].x;
            float y_kyori = a_unit[ i_teki].y - a_unit[ i_mikata].y;
            float kyori = sqrt( x_kyori * x_kyori + y_kyori * y_kyori);
    
            if( wk_kyori > kyori){
                wk_kyori = kyori; 
                nerai1 = i_mikata; 
            }
        
            if( wk_hpzan < a_unit[ i_mikata].hp - a_unit[ i_mikata].hpzan){
                wk_hpzan = a_unit[ i_mikata].hp - a_unit[ i_mikata].hpzan; 
                nerai2 = i_mikata; 
            }
        }

    }
        
    if(    a_unit[ i_teki ].x + 48 * 3 >= a_unit[ nerai2 ].x
        && a_unit[ i_teki ].x - 48 * 3 <= a_unit[ nerai2 ].x
        && a_unit[ i_teki ].y + 48 * 3 >= a_unit[ nerai2 ].y
        && a_unit[ i_teki ].y - 48 * 3 <= a_unit[ nerai2 ].y
                                                              ){
        nerai = nerai2;                                                           
    }                                                            
    else{
        nerai = nerai1;                                                           
    }    
            
    return nerai;

}


//***********************************************************************


int SimMikataTansaku(
    simulation_unit *a_unit,
    int i_mikata,
    int n_teki ){

    /******************************************************************
    *                                                                 *
    * ANXAAgXAm͈ԋ߂G˂炤                *
    *                                                                 *
    ******************************************************************/

    int i_teki;
    
    float wk_kyori = 10000;
    int nerai = 0;


    for( i_teki = 30 ; i_teki < n_teki ; i_teki++){

        if( a_unit[ i_teki].hpzan > 0){

            float x_kyori = a_unit[ i_mikata].x - a_unit[ i_teki].x;
            float y_kyori = a_unit[ i_mikata].y - a_unit[ i_teki].y;
            float kyori = sqrt( x_kyori * x_kyori + y_kyori * y_kyori);
    
            if( wk_kyori > kyori){
                wk_kyori = kyori; 
                nerai = i_teki; 
            }
        }
    }

    return nerai;

}


//**********************************************************************


int SimMaTansaku(
    struct simulation_unit *a_unit,
    int i_mikata,
    int n_teki ){

    /******************************************************************
    *                                                                 *
    * }^͈ԉG˂炤                                      *
    *                                                                 *
    ******************************************************************/

    int i_teki;
    
    float wk_kyori = 0;
    int nerai = 0;


    for( i_teki = 30 ; i_teki < n_teki ; i_teki++){

        if( a_unit[ i_teki].hpzan > 0){

            float x_kyori = a_unit[ i_mikata].x - a_unit[ i_teki].x;
            float y_kyori = a_unit[ i_mikata].y - a_unit[ i_teki].y;
            float kyori = sqrt( x_kyori * x_kyori + y_kyori * y_kyori);
    
            if( wk_kyori < kyori){
                wk_kyori = kyori; 
                nerai = i_teki; 
            }
        }
    }

    return nerai;

}

//**********************************************************************

int SimKeKariTansaku(
    simulation_unit *a_unit,
    int i_mikata,
    int n_teki ){

    /******************************************************************
    *                                                                 *
    * Pr͂܂ԎĂGɂ˂炢ړ              *
    *                                                                 *
    ******************************************************************/

    int i_teki;
    
    int wk_hpzan = 10000;
    int nerai = 0;


    for( i_teki = 30 ; i_teki < n_teki ; i_teki++){

        if(    a_unit[ i_teki].hpzan > 0
            && wk_hpzan > a_unit[ i_teki].hpzan
                                                 ){
                wk_hpzan = a_unit[ i_teki].hpzan; 
                nerai = i_teki; 
        
        }
    }
    
    return nerai;

}

//**********************************************************************

int SimKeSaiTansaku(
    simulation_unit *a_unit,
    int i_mikata,
    int n_teki){

    /******************************************************************
    *                                                                 *
    * Pr͈ړA˂Gɓ͂Ȃ΁A                  *
    * U͈͂̈ԎアGɂ˂炢                            *
    *                                                                 *
    ******************************************************************/

    int i_teki;
    
    int wk_hpzan = 10000;
    int nerai = 0;

    for( i_teki = 30 ; i_teki < n_teki ; i_teki++){
    
        if(
               a_unit[ i_teki].hpzan > 0                                   
            && wk_hpzan > a_unit[ i_teki].hpzan                   
            && a_unit[ i_mikata ].x + 48 * 2 >= a_unit[ i_teki ].x
            && a_unit[ i_mikata ].x - 48 * 2 <= a_unit[ i_teki ].x
            && a_unit[ i_mikata ].y + 48 * 2 >= a_unit[ i_teki ].y
            && a_unit[ i_mikata ].y - 48 * 2 <= a_unit[ i_teki ].y
                                                                  ){
            wk_hpzan = a_unit[ i_teki].hpzan; 
            nerai = i_teki;
             
            
        }
    
    }
            
    return nerai;

}

