#include "dofd.h"
                             
int Simulation(
    shujinko *a_se,
    shujinko *a_le,
    gazo_gun  *a_ga ,
    switch_gun *a_sw){

    /******************************************************************
    *                                                                 *
    * V~[V̗K                                          *
    *                                                                 *
    * S̍UAGSUA^[                    *
    * ANXΕB                                      *
    * GS|ΏBG͓rR𑗂ĂB                  *
    *                                                                 *
    ******************************************************************/

    int i, j;
    int i_mikata, i_teki;
    int svi, svj;
    int hai_iie;
    int sim_yaru = OFF;
    int n_mikata, n_teki;
    int nerai;
    int mikata_zan, teki_zan;
    int sw_al = 0;
    int sw_ke_meirei = 0;
    int delay_counter;
    int delay_flip;
    int ma_yarare = NO;
    int at_yarare = NO;
    int ar_yarare = NO;
    int ke_yarare = NO;
    int sw_engun = NO;
        
    int aa_ban[ 8][ 8];
    
    for( j = 0 ; j < 8 ; j++){
        for( i = 0 ; i < 8 ; i++){
            aa_ban[ j][ i] = OFF;
        }
    }

    n_mikata = 19;
    mikata_zan = n_mikata - 10;
   
    struct simulation_unit a_unit[ 60];

    for( i_mikata = 10 ; i_mikata < n_mikata ; i_mikata++){

        j = GetRand( 7);
        i = GetRand( 7);
       
        svj = j;
        svi = i;
         
        while( aa_ban[ j][ i] > 0 ){
            j += 1;
            i += 2;
            if( j == 8){ j = 0;}
            if( i == 8){ i = 0;}
            else if( i == 9 ){i = 1;}
            else{}
            if( j == svj ){ i += 1;}               
        }

        aa_ban[ j][ i] = i_mikata;

        a_unit[ i_mikata].num =  i_mikata;

        a_unit[ i_mikata].x =  i  * 48 + 208 ;
        a_unit[ i_mikata].y =  j  * 48 +  48 ;



        if( i_mikata == 10){      strcpy( a_unit[ i_mikata].a_name ,  "ANX");}
        else if( i_mikata == 11){ strcpy( a_unit[ i_mikata].a_name ,  "}^");}
        else if( i_mikata == 12){ strcpy( a_unit[ i_mikata].a_name ,  "AgX");}
        else if( i_mikata == 13){ strcpy( a_unit[ i_mikata].a_name ,  "A[");}
        else if( i_mikata == 14){ strcpy( a_unit[ i_mikata].a_name ,  "Pr");}
        else{                     strcpy( a_unit[ i_mikata].a_name ,  "ANXR");}

        if( i_mikata == 10){      strcpy( a_unit[ i_mikata].a_job ,  "m");}
        else if( i_mikata == 11){ strcpy( a_unit[ i_mikata].a_job ,  "|g");}
        else if( i_mikata == 12){ strcpy( a_unit[ i_mikata].a_job ,  "g");}
        else if( i_mikata == 13){ strcpy( a_unit[ i_mikata].a_job ,  "t");}
        else if( i_mikata == 14){ strcpy( a_unit[ i_mikata].a_job ,  "g");}
        else{                     strcpy( a_unit[ i_mikata].a_job ,  "m");}

        if( i_mikata == 10){      a_unit[ i_mikata].hosu = 2;}
        else if( i_mikata == 11){ a_unit[ i_mikata].hosu = 2;}
        else if( i_mikata == 12){ a_unit[ i_mikata].hosu = 1;}
        else if( i_mikata == 13){ a_unit[ i_mikata].hosu = 1;}
        else if( i_mikata == 14){ a_unit[ i_mikata].hosu = 2;}
        else{                     a_unit[ i_mikata].hosu = 2;}

        if( i_mikata == 10){      a_unit[ i_mikata].shatei = 1;}
        else if( i_mikata == 11){ a_unit[ i_mikata].shatei = 7;}
        else if( i_mikata == 12){ a_unit[ i_mikata].shatei = 1;}
        else if( i_mikata == 13){ a_unit[ i_mikata].shatei = 2;}
        else if( i_mikata == 14){ a_unit[ i_mikata].shatei = 2;}
        else{                     a_unit[ i_mikata].shatei = 1;}

        if( i_mikata == 10){      a_unit[ i_mikata].hp = 4500;}
        else if( i_mikata == 11){ a_unit[ i_mikata].hp = 2500;}
        else if( i_mikata == 12){ a_unit[ i_mikata].hp = 5500;}
        else if( i_mikata == 13){ a_unit[ i_mikata].hp = 2200;}
        else if( i_mikata == 14){ a_unit[ i_mikata].hp = 3700;}
        else{                     a_unit[ i_mikata].hp 
                                      = 3000 + GetRand( 5) * 100;}

        a_unit[ i_mikata].hpzan = a_unit[ i_mikata].hp;

        if( i_mikata == 10){      a_unit[ i_mikata].kogeki  =  2100;}
        else if( i_mikata == 11){ a_unit[ i_mikata].kogeki  =  2000;}
        else if( i_mikata == 12){ a_unit[ i_mikata].kogeki  =  2400;}
        else if( i_mikata == 13){ a_unit[ i_mikata].kogeki  =   500;}
        else if( i_mikata == 14){ a_unit[ i_mikata].kogeki  =  1800;}
        else{                     a_unit[ i_mikata].kogeki  
                                      =  1000 + GetRand( 5) * 100;}

        if( i_mikata == 10){      a_unit[ i_mikata].hangeki =  1500;}
        else if( i_mikata == 11){ a_unit[ i_mikata].hangeki =  1500;}
        else if( i_mikata == 12){ a_unit[ i_mikata].hangeki =  2400;}
        else if( i_mikata == 13){ a_unit[ i_mikata].hangeki =  1500;}
        else if( i_mikata == 14){ a_unit[ i_mikata].hangeki =  1500;}
        else{                     a_unit[ i_mikata].hangeki 
                                      =  1000 + GetRand( 5) * 100;}


        a_unit[ i_mikata].tsukamu = OFF;
        a_unit[ i_mikata].ido = OFF;
    }

    
    n_teki = 44 + GetRand( 1);

    teki_zan = n_teki - 30;
    
    for( i_teki = 30 ; i_teki < n_teki ; i_teki++){

        j = GetRand( 7);
        i = GetRand( 7);
       
        svj = j;
        svi = i;
         
        while( aa_ban[ j][ i] > 0 ){
            i += 1;
            j += 2;
            if( i == 8){ i = 0;}
            if( j == 8){ j = 0;}
            else if( j == 9 ){j = 1;}
            else{}
            if( i == svi ){ j += 1;}               
        }

        aa_ban[ j][ i] = i_teki;

        a_unit[ i_teki].num =  i_teki;

        a_unit[ i_teki].x =  i  * 48 + 208 ;
        a_unit[ i_teki].y =  j  * 48 +  48 ;

        if( i_teki == 30){      strcpy( a_unit[ i_teki].a_name , "ڸװ");}
        else if( i_teki == 31){ strcpy( a_unit[ i_teki].a_name , "װ");}
        else if( i_teki == 32){ strcpy( a_unit[ i_teki].a_name , "׽װ");}
        else{                   strcpy( a_unit[ i_teki].a_name , "ތR");}

        strcpy( a_unit[ i_teki].a_job , "t");

        if( i_teki == 30){      a_unit[ i_teki].hosu = 2;}
        else if( i_teki == 31){ a_unit[ i_teki].hosu = 2;}
        else if( i_teki == 32){ a_unit[ i_teki].hosu = 2;}
        else{                   a_unit[ i_teki].hosu = 1;}

        a_unit[ i_teki].shatei = 2;


        a_unit[ i_teki].hp = 2000 + GetRand( 4) * 100;
        a_unit[ i_teki].hpzan = a_unit[ i_teki].hp;
        a_unit[ i_teki].kogeki =  1000 + GetRand( 3) * 100;
        a_unit[ i_teki].hangeki =  500 + GetRand( 2) * 100;
        
    }

    //**************************************************************

    while(     ProcessMessage() == 0
            && CheckHitKey( KEY_INPUT_ESCAPE) == 0 ){
    
        ClsDrawScreen();

        SimBan( a_ga , aa_ban );

        if( sim_yaru == OFF ){
            hai_iie =
                HaiIie(
                    a_se,
                    a_le,
                    a_ga,
                    a_sw,
                    "̂̐킢ČĂ݂H",
                    LE
                );
        }
        
        if ( hai_iie == IIE ){
            a_se->x = SHIRO_KITA_X + 32 * 4;
            a_se->y = SHIRO_KITA_Y + 32;
            a_se->muki = SHITA;
            a_sw->oh_boken = BOKEN;
            return 0;
        }
        else{
            sim_yaru = ON;
        }

        SimHaichi( a_unit , a_ga , aa_ban );

        BunYomi(
            a_ga,
            "media\\sim_al_kogeki.txt"
        );

        for( i_mikata = 10 ; i_mikata < n_mikata ; i_mikata++ ){
            a_unit[ i_mikata].ido = 0;
        }

        for( i_mikata = 10 ; i_mikata < n_mikata ; i_mikata++ ){
            if(    a_unit[ i_mikata].hpzan > 0
                && a_unit[ i_mikata].ido == 0
                                                ){
                SimMikataHaichi(
                    a_unit,
                    i_mikata,
                    n_mikata,
                    n_teki,
                    &mikata_zan,
                    &teki_zan,
                    &sw_ke_meirei,
                    a_ga,
                    aa_ban
                );

            }
        }

        sw_al = ON;

        for( i = 0 ; i < 2 ; i++){//ANXQU
            if( a_unit[ 10].hpzan > 0){
                nerai = SimMikataTansaku( a_unit, 10, n_teki );
                if( nerai > 0 ){
                    SimMikataKogeki(
                        a_unit , 
                        10 , 
                        nerai ,
                        n_teki,
                        &sw_al, 
                        a_ga , 
                        aa_ban 
                    );
                }
            }
        }

        if( a_unit[ 13].hpzan > 0){//A[
            for( i_teki = 30 ; i_teki < n_teki ; i_teki++){        
                SimArKogekiAnime(
                    a_unit , 
                    13 , 
                    i_teki ,
                    a_ga , 
                    aa_ban 
                );
            }
        }
        delay_flip = 20;//A[ŨfC
        DELAY

        if( a_unit[ 14].hpzan > 0){//Pr #1

            nerai =
                SimKeKariTansaku(
                    a_unit,
                    14,
                    n_teki
                );
            
            if( nerai > 0){
                SimKeKogeki(
                    a_unit,
                    14,
                    nerai,
                    n_teki,
                    &sw_al,
                    a_ga,
                    aa_ban
                );
            }
        }

        for( i_mikata = 11 ; i_mikata < n_mikata ; i_mikata++ ){
            
            if( a_unit[ i_mikata].hpzan > 0){

                if( i_mikata == 11){
                    nerai = SimMaTansaku( a_unit, i_mikata, n_teki );
                }
                else if( i_mikata == 13){
                    goto ar_ke_tobisaki;
                }
                else if( i_mikata == 14){
                    goto ar_ke_tobisaki;
                }
                else{
                    nerai = SimMikataTansaku( a_unit, i_mikata, n_teki );
                }

                if( nerai > 0 ){
                    SimMikataKogeki(
                        a_unit , 
                        i_mikata , 
                        nerai ,
                        n_teki,
                        &sw_al, 
                        a_ga , 
                        aa_ban 
                    );
                }
                
                ar_ke_tobisaki:
            }
        }

        if( a_unit[ 14].hpzan > 0){//Pr #2

            nerai =
                SimKeKariTansaku(
                    a_unit,
                    14,
                    n_teki
                );
            
            if( nerai > 0){
                SimKeKogeki(
                    a_unit,
                    14,
                    nerai,
                    n_teki,
                    &sw_al,
                    a_ga,
                    aa_ban
                );
            }
        }

        
        //********************G*********************


        BunYomi(
            a_ga,
            "media\\sim_ga_kogeki.txt"
        );

        for( i_teki = 30 ; i_teki < n_teki ; i_teki++){
    
            if( a_unit[ i_teki].hpzan > 0){

                if( i_teki == 30){
                    nerai = 10;
                }
                else if( i_teki == 31){
                    if( a_unit[ 11].hpzan > 0){
                        nerai = 11;
                    }
                    else{
                        nerai = SimTekiTansaku( a_unit , i_teki , n_mikata);
                    }
                }
                else if( i_teki == 32){
                    if( a_unit[ 12].hpzan > 0){
                        nerai = 12;
                    }
                    else{
                        nerai = SimTekiTansaku( a_unit , i_teki , n_mikata);
                    }
                }
                else{    
                    nerai = SimTekiTansaku( a_unit , i_teki , n_mikata);
                }
                
                if( nerai > 0 ){
                    SimTekiKogeki(
                        a_unit , 
                        i_teki , 
                        nerai , 
                        a_ga , 
                        aa_ban 
                    );
                }
            }
        }

        if( a_unit[ 10].hpzan <= 0){
            BunYomi(
                a_ga,
                "media\\sim_al_yarare.txt"
            );
            a_sw->oh_boken = SIMULATION;
            return 0;
        }

        if(    a_unit[ 11].hpzan <= 0
            && ma_yarare == NO        ){
            BunYomi(
                a_ga,
                "media\\sim_ma_yarare.txt"
            );
            ma_yarare = YES;
        }

        if(    a_unit[ 12].hpzan <= 0
            && at_yarare == NO        ){
            BunYomi(
                a_ga,
                "media\\sim_at_yarare.txt"
            );
            at_yarare = YES;
        }

        if(    a_unit[ 13].hpzan <= 0
            && ar_yarare == NO        ){
            BunYomi(
                a_ga,
                "media\\sim_ar_yarare.txt"
            );
            ar_yarare = YES;
        }
        if(    a_unit[ 14].hpzan <= 0
            && ke_yarare == NO        ){
            BunYomi(
                a_ga,
                "media\\sim_ke_yarare.txt"
            );
            ke_yarare = YES;
        }

        mikata_zan = 0;
        for( i_mikata = 10 ; i_mikata < n_mikata ; i_mikata++){
    
            if( a_unit[ i_mikata].hpzan > 0){
                mikata_zan++;
            }
        }

        teki_zan = 0;
        for( i_teki = 30 ; i_teki < n_teki ; i_teki++){
    
            if( a_unit[ i_teki].hpzan > 0){
                teki_zan++;
            }
        }


        if( teki_zan == 0 ){
            BunYomi(
                a_ga,
                "media\\sim_kachi.txt"
            );
            a_sw->oh_boken = SIMULATION;
            return 0;
        }
        else if(     teki_zan <= 4
                 &&  sw_engun == NO ){
            BunYomi(
                a_ga,
                "media\\sim_engun.txt"
            );

            sw_engun = YES;

            int n_teki_sv = n_teki;

            n_teki = n_teki + mikata_zan - teki_zan + 2;
            
            teki_zan = mikata_zan + 2;

            for( i_teki = n_teki_sv ; i_teki < n_teki ; i_teki++){
        
                j = GetRand( 7);
                i = GetRand( 7);
               
                svj = j;
                svi = i;
                 
                while( aa_ban[ j][ i] > 0 ){
                    i += 1;
                    j += 2;
                    if( i == 8){ i = 0;}
                    if( j == 8){ j = 0;}
                    else if( j == 9 ){j = 1;}
                    else{}
                    if( i == svi ){ j += 1;}               
                }
        
                aa_ban[ j][ i] = i_teki;
        
                a_unit[ i_teki].num =  i_teki;
        
                a_unit[ i_teki].x =  i  * 48 + 208 ;
                a_unit[ i_teki].y =  j  * 48 +  48 ;
        
                strcpy( a_unit[ i_teki].a_name , "ތR");
                strcpy( a_unit[ i_teki].a_job , "t");
                a_unit[ i_teki].hosu = 1;
                a_unit[ i_teki].shatei = 2;
                a_unit[ i_teki].hp = 2000 + GetRand( 4) * 100;
                a_unit[ i_teki].hpzan = a_unit[ i_teki].hp;
                a_unit[ i_teki].kogeki =  1000 + GetRand( 3) * 100;
                a_unit[ i_teki].hangeki =  500 + GetRand( 2) * 100;
                
            }

        }
        else{}

        ScreenFlip();

    }
    return 0;
}



